#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QMap>

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    QString vertexShader;
    QString fragmentShader;

    QMap<QString, std::string> vertexShaders;
    QMap<QString, std::string> fragmentShaders;

    bool culling = false;

private slots:
    void on_action_Version_OpenGL_triggered();

    void on_actionHello_triangle_triggered();
    void on_actionHello_camera_triggered();
    void on_actionHello_spheres_triggered();
    void on_actionHello_spline_triggered();
    void on_actionHello_clear_triggered();

    void on_actionToggle_Back_Face_Culling_triggered(bool checked);

private:
    Ui::MainWindow *ui;

    void addShaders();
};

#endif // MAINWINDOW_H
