#version 410 core
in      vec3    position;
uniform vec3    center;
uniform float   radius;
uniform float   errorMax;
out     vec4    color;

void main()
{
    // Colors
    vec4 bleu = vec4(0.094, 0, 1.0, 1.0);
    vec4 vert = vec4(0.07, 1.0, 0, 1.0);
    vec4 jaune = vec4(0.94, 1.0, 0, 1.0);
    vec4 rouge = vec4(1.0, 0, 0, 1.0);

    // Compute Value
    float value = smoothstep(0.0, errorMax, abs(length(center - position) - radius) / radius);
    color = bleu; // Init color

    // Heatmap gradient
    if (value < 0.85) {
        value = smoothstep(0.0, 0.85, value);
        color = mix(bleu, vert, value);
    }
    else if (value < 0.95) {
        value = smoothstep(0.85, 0.95, value);
        color = mix(vert, jaune, value);
    }
    else {
        value = smoothstep(0.95, 1.0, value);
        color = mix(jaune, rouge, value);
    }
}
